/*
 * 作成日： 2004/08/21
 *
 * TODO この生成されたファイルのテンプレートを変更するには次を参照。
 * ウィンドウ ＞ 設定 ＞ Java ＞ コード・スタイル ＞ コード・テンプレート
 */
package dictionary;

import java.util.*;

/**
 * @author Administrator Sho Hashimoto
 *
 * TODO この生成された型コメントのテンプレートを変更するには次を参照。
 * ウィンドウ ＞ 設定 ＞ Java ＞ コード・スタイル ＞ コード・テンプレート
 */
public class WordSet extends TreeSet {
    
    private String name; // 辞書の名前、ファイル名
    private String extension = ".xml"; // 拡張子
    
    public WordSet(){
        this.setName("new_dictionary");
    }
    
    public WordSet(String name){
        this.setName(name);
    }
    
    
    /*
     * nameを持つWordを返す
     */
    public Word get(String name){
        Iterator i = this.iterator();
        while(i.hasNext()){
            Word w = (Word)i.next();
            if(w.toString().equals(name)){
                return w;
            }
        }
        return new Word();
    }

    /*
     * nameを持つWordを削除する
     * 成功すれば return true;
     */
    public boolean remove(String name){
        return this.remove(this.get(name)); // get()してremove()
    }
    
    /*
     * nameを持つWordが在ればTrue
     */
    public boolean contains(String name){
        Iterator i = this.iterator();
        while(i.hasNext()){
            Word w = (Word)i.next();
            if(w.toString().equals(name)){
                return true;
            }
        }
        return false;
    }
    
    /*
     * Collection.toArray()をオーバーライドした配列生成メソッド
     * @see java.util.Collection#toArray()
     */
    public Object[] toArray(){
        Object obj[] = new Object[this.size()];
        Iterator i = this.iterator();
        int j = 0;
        while(i.hasNext()){
            obj[j++] = i.next().toString();
        }
        return obj;
    }
        
    /**
     * @return name
     */
    public String getName() {
        return this.name;
    }
    /**
     * @param name name を設定します。
     */
    public void setName(String name) {
        this.name = name;
    }
    /**
     * @return ファイル名を生成して返す
     */
    public String getFileName(){
        return this.name + this.extension;
    }
}
